=== modified file 'src/com/goldencode/p2j/ui/TreeWidgetBase.java' (properties changed: +x to -x)
--- src/com/goldencode/p2j/ui/TreeWidgetBase.java	2021-06-01 18:55:22 +0000
+++ src/com/goldencode/p2j/ui/TreeWidgetBase.java	2021-06-17 18:05:43 +0000
@@ -131,17 +131,9 @@
 
 /**
  * Server side Tree widget base implementation.
- * @param <N> 
- *        node type
- * @param <C> 
- *        config type
- * @param <R> 
- *        resource type
  */
-public abstract class TreeWidgetBase<N extends TreeNodeEntry,
-                                     C extends TreeConfig<N>,
-                                     R extends TreeNodeResource<N>>
-extends ControlEntityExt<C>
+public abstract class TreeWidgetBase
+extends ControlEntityExt<TreeConfig>
 implements TreeFace
 {
    /**
@@ -152,22 +144,22 @@
    /**
     * Map of nodes by ids.
     */
-   private HashMap<Integer, R> nodesById = new HashMap<>();
+   private HashMap<Integer, TreeNodeFace > nodesById = new HashMap<>();
 
    /**
     * Map of nodes by keys.
     */
-   private HashMap<String, R> nodesByKey = new HashMap<>();
+   private HashMap<String, TreeNodeFace > nodesByKey = new HashMap<>();
 
    /**
     * The list of all tree nodes.
     */
-   private LinkedList<R> nodesByIndices = new LinkedList<>();
+   private LinkedList<TreeNodeFace > nodesByIndices = new LinkedList<>();
 
    /**
     * The root node.
     */
-   private R rootNode;
+   private TreeNodeFace rootNode;
 
    /**
     * The backed field for BUILDING-TREE attribute.
@@ -178,10 +170,10 @@
    private boolean pendingPushNodes;
 
    /** Widget attributes pending to be sent to the client */
-   private ArrayList<String> pendingAttrs = new ArrayList<>();
+   private List<String> pendingAttrs = new ArrayList<>();
 
    /** Widget attribute values pending to be sent to the client */
-   private ArrayList<Object> pendingAttrValues = new ArrayList<>();
+   private List<Object> pendingAttrValues = new ArrayList<>();
 
    /** Assigned imagelist for node images. */
    private handle nodeImageListHandle;
@@ -197,7 +189,7 @@
     * @param    ctrl
     *           Configuration container.
     */
-   public TreeWidgetBase(boolean dynamic, C ctrl)
+   public TreeWidgetBase(boolean dynamic, TreeConfig ctrl)
    {
       super(dynamic, ctrl);
       rootNode = createNode("", "", null);
@@ -218,14 +210,14 @@
     *          the owner's config was modified.
     */
    @Override
-   public void afterConfigUpdate(C beforeUpdate)
+   public void afterConfigUpdate(TreeConfig beforeUpdate)
    {
-      for (N e : getAttr("nodes", () -> config.nodes))
+      for (TreeNodeEntry e : getAttr("nodes", () -> config.nodes))
       {
-         TreeNodeResource<N> node = nodesById.get(e.nodeId);
+         TreeNodeFace node = nodesById.get(e.nodeId);
          if (node != null)
          {
-            node.loadFromEntry(e);
+            ((TreeNodeResource)node).loadFromEntry(e);
          }
       }
 
@@ -350,7 +342,7 @@
    public handle getDraggedNode()
    {
       int nodeId = getAttr("draggedNode", () -> config.draggedNode);
-      R node = findNode(nodeId);
+      TreeNodeFace node = findNode(nodeId);
       return new handle(node);
    }
 
@@ -363,7 +355,7 @@
    public handle getDraggedOverNode()
    {
       int nodeId = getAttr("draggedOverNode", () -> config.draggedOverNode);
-      R node = findNode(nodeId);
+      TreeNodeFace node = findNode(nodeId);
       return new handle(node);
    }
 
@@ -381,7 +373,8 @@
          return new handle();
       }
       
-      TreeNodeResource<N> node = nodesById.get(getAttr("dropHighlightNodeId", () -> config.dropHighlightNodeId));
+      TreeNodeFace node = nodesById
+               .get(getAttr("dropHighlightNodeId", () -> config.dropHighlightNodeId));
       
       return new handle(node);
    }
@@ -420,7 +413,7 @@
    /**
     * Getter for the SELECTED-NODE attribute.
     * The method returns a handle the currently selected node or tree root node handle when no node
-    * is currently selected. The handle will wrap an instance of {@link TreeNodeFace}.
+    * is currently selected. The handle will wrap an instance of {@link TreeNodeFace }.
     *
     * @return  the attribute value.
     */
@@ -523,7 +516,7 @@
          return new character();
       }
 
-      return ((TreeNodeResource<N>) node.getResource()).getNodeKey();
+      return ((TreeNodeResource) node.getResource()).getNodeKey();
    }
 
    /**
@@ -557,7 +550,7 @@
          return new character();
       }
 
-      return ((TreeNodeResource<N>) node.getResource()).getNodeKey();
+      return ((TreeNodeResource) node.getResource()).getNodeKey();
    }
 
    /**
@@ -569,7 +562,7 @@
    @Override
    public handle getNodes()
    {
-      return rootNode.getNodes();
+      return ((TreeNodeResource)rootNode).getNodes();
    }
 
    /**
@@ -614,7 +607,7 @@
    public integer getVisibleNodeCount()
    {
       int count = 0;
-      Iterator<?> it = rootNode._getNodes().recursiveIterator(true);
+      Iterator<?> it = ((TreeNodeResource)rootNode)._getNodes().recursiveIterator(true);
       while(it.hasNext())
       {
          it.next();
@@ -633,13 +626,13 @@
    @Override
    public handle getFirstVisibleNode()
    {
-      int nodeId = getAttr("topNode", () -> config.topNode, true);
+      int nodeId = _getTopVisibleNodeId();
       if (nodeId <= 0)
       {
          return new handle(rootNode);
       }
 
-      R node = findNode(nodeId);
+       TreeNodeFace node = findNode(nodeId);
       return new handle(node);
    }
 
@@ -651,8 +644,8 @@
    @Override
    public integer getFirstNode()
    {
-      TreeNodeResource<N> node = rootNode._getNodes()._getNode(0);
-      return node == null ? new integer() : new integer(node._getNodeId());
+       TreeNodeFace node = ((TreeNodeResource)rootNode)._getNodes()._getNode(0);
+      return node == null ? new integer() : new integer(((TreeNodeResource)node)._getNodeId());
    }
 
    /**
@@ -665,16 +658,16 @@
    public integer getNextNode(NumberType nodeId)
    {
       boolean found = false;
-      Iterator<TreeNodeResource<N>> it = rootNode._getNodes().recursiveIterator(true);
+      Iterator<TreeNodeFace> it = ((TreeNodeResource)rootNode)._getNodes().recursiveIterator(true);
       while(it.hasNext())
       {
-         TreeNodeResource<N> node = it.next();
+         final TreeNodeFace node = it.next();
          if (found)
          {
-            return node.getNodeId();
+            return ((TreeNodeResource)node).getNodeId();
          }
 
-         found = rootNode._getNodeId() == nodeId.intValue();
+         found = ((TreeNodeResource)rootNode)._getNodeId() == nodeId.intValue();
       }
 
       return new integer();
@@ -707,7 +700,7 @@
    @Override
    public integer getNodeFgColor(NumberType nodeId)
    {
-      return doWithNode(nodeId, null, new integer(), n -> new integer(n.getFgColor()));
+      return doWithNode(nodeId, null, new integer(), n -> new integer(((TreeNodeResource)n).getFgColor()));
    }
 
    /**
@@ -724,7 +717,7 @@
    {
       doWithNode(nodeId, new BaseDataType[] {fgrValue}, n ->
       {
-         n.setFgColor(fgrValue.intValue());
+         ((TreeNodeResource)n).setFgColor(fgrValue.intValue());
          pushNodes();
       });
    }
@@ -742,7 +735,7 @@
    @Override
    public integer getNodeBgColor(NumberType nodeId)
    {
-      return doWithNode(nodeId, null, new integer(), n -> new integer(n.getFgColor()));
+      return doWithNode(nodeId, null, new integer(), n -> new integer(((TreeNodeResource)n).getFgColor()));
    }
 
    /**
@@ -758,7 +751,7 @@
    {
       doWithNode(nodeId, new BaseDataType[] {bgrValue}, n ->
       {
-         n.setBgColor(bgrValue.intValue());
+         ((TreeNodeResource)n).setBgColor(bgrValue.intValue());
          pushNodes();
       });
    }
@@ -889,37 +882,37 @@
       }
 
       final int id = parentNodeId.intValue();
-      final TreeNodeResource<N> parent = id == 0 ? rootNode : findNode(parentNodeId.intValue());
+      final  TreeNodeFace parent = id == 0 ? rootNode : findNode(parentNodeId.intValue());
       if (parent == null)
       {
          return;
       }
 
-      final handle hnode = parent._getNodes()._addNodeImpl(null, TreeNodeCollectionResource.Location.LAST,
+      final handle hnode = ((TreeNodeResource)parent)._getNodes()._addNodeImpl(null, TreeNodeCollectionResource.Location.LAST,
                                                      nodeKey, nodeText, false);
       if (hnode == null || hnode.isUnknown())
       {
          return;
       }
 
-      TreeNodeResource<N> node = (TreeNodeResource<N>) hnode.getResource();
-      node.setNodeIcon(collapseIcon);
-      node.setExpandNodeIcon(expandIcon);
+      final  TreeNodeFace node = (TreeNodeResource) hnode.getResource();
+      ((TreeNodeResource)node).setNodeIcon(collapseIcon);
+      ((TreeNodeResource)node).setExpandNodeIcon(expandIcon);
       if (hasChildren != null && !hasChildren.isUnknown())
       {
-         node._setHasChildren(hasChildren.booleanValue());
+         ((TreeNodeResource)node)._setHasChildren(hasChildren.booleanValue());
       }
 
       if (tooltip != null && !tooltip.isUnknown())
       {
-         node._setTooltip(tooltip.getValue());
+         ((TreeNodeResource)node)._setTooltip(tooltip.getValue());
       }
 
       pushNodes();
 
       if (BaseDataType.isAllKnown(newNodeId))
       {
-         newNodeId.assign(node.getNodeId());
+         newNodeId.assign(((TreeNodeResource)node).getNodeId());
       }
    }
 
@@ -962,17 +955,18 @@
    public void removeNode(NumberType nodeId)
    {
       doWithNode(nodeId, null, n -> {
-         final TreeNodeResource<N> parent = n._getParent();
+         final TreeNodeFace parent = ((TreeNodeResource)n)._getParent();
          // We are not going to delete the tree root!
          assert parent != null;
 
-         final TreeNodeCollectionResource<N, C, R> children = parent._getNodes();
+         final TreeNodeCollectionResource children = ((TreeNodeResource)parent)._getNodes();
 
          /**
           * If the selected node is being deleted or the selected node descends from
           * the node being deleted, adjust the selection.
           */
-         for (R node = _getSelectedNode(); node != rootNode; node = (R) node._getParent())
+         for (TreeNodeFace node = _getSelectedNode(); node != rootNode; node = ((TreeNodeResource) node)
+                  ._getParent())
          {
             if (node == n)
             {
@@ -985,7 +979,7 @@
                final int nodeChildIndex = children._indexOf(n);
                assert nodeChildIndex >= 0;
 
-               final TreeNodeResource<N> newFocused;
+               final  TreeNodeFace newFocused;
                if (nodeChildIndex > 0)
                {
                   newFocused = children._getNode(nodeChildIndex - 1);
@@ -1003,14 +997,14 @@
                   newFocused = rootNode;
                }
 
-               _setSelectedNode(newFocused._getNodeId());
+               _setSelectedNode(((TreeNodeResource)newFocused)._getNodeId());
 
                break;
             }
          }
          
          children._removeNode(n, null);
-         parent._setHasChildren(children._getCount() != 0);
+         ((TreeNodeResource)parent)._setHasChildren(children._getCount() != 0);
 
          pushNodes();
       });
@@ -1027,7 +1021,7 @@
    @Override
    public logical isNodeExpanded(NumberType nodeId)
    {
-      return doWithNode(nodeId, null, new logical(), n -> n.isNodeExpanded());
+      return doWithNode(nodeId, null, new logical(), n -> ((TreeNodeResource)n).isNodeExpanded());
    }
 
    /**
@@ -1039,7 +1033,7 @@
    @Override
    public void expandNode(NumberType nodeId)
    {
-      doWithNode(nodeId, null, n -> n.setNodeExpanded(new logical(true)));
+      doWithNode(nodeId, null, n -> ((TreeNodeResource)n).setNodeExpanded(new logical(true)));
    }
 
    /**
@@ -1053,7 +1047,7 @@
    {
       doWithNode(nodeId, null, n -> 
       {
-         n.setNodeExpanded(new logical(false));
+         ((TreeNodeResource)n).setNodeExpanded(new logical(false));
          doSelectAfterCollapse(n);
       });
    }
@@ -1064,7 +1058,7 @@
    @Override
    public void clearAll()
    {
-      rootNode._removeCollection();
+      ((TreeNodeResource)rootNode)._removeCollection();
    }
 
    /**
@@ -1170,13 +1164,12 @@
    {
       doWithNode(nodeId, new BaseDataType[] {outChildId, outChildKey}, n ->
       {
-         TreeNodeCollectionResource<N,C,R> col = n._getNodes();
+         final TreeNodeCollectionResource col = ((TreeNodeResource)n)._getNodes();
          if (col._getCount() > 0)
          {
-            TreeNodeResource<N> result = null;
-            result = col._getNode(0);
-            outChildId.assign(result._getNodeId());
-            outChildKey.assign(result._getNodeKey());
+            final TreeNodeFace result = col._getNode(0);
+            outChildId.assign(((TreeNodeResource)result)._getNodeId());
+            outChildKey.assign(((TreeNodeResource)result)._getNodeKey());
          }
       });
    }
@@ -1196,16 +1189,16 @@
    {
       doWithNode(nodeId, new BaseDataType[] {outSiblingId, outSiblingKey}, n ->
       {
-         TreeNodeResource<N> parent = n._getParent();
+          TreeNodeFace parent = ((TreeNodeResource)n)._getParent();
          if (parent != null)
          {
-            TreeNodeCollectionResource<N,C,R> col = parent._getNodes();
+            TreeNodeCollectionResource col = ((TreeNodeResource)parent)._getNodes();
             int i = col._indexOf(n);
             if (i >= 0 && i < col._getCount() - 1)
             {
-               TreeNodeResource<N> result = col._getNode(i + 1);
-               outSiblingId.assign(result._getNodeId());
-               outSiblingKey.assign(result._getNodeKey());
+               final TreeNodeFace result = col._getNode(i + 1);
+               outSiblingId.assign(((TreeNodeResource)result)._getNodeId());
+               outSiblingKey.assign(((TreeNodeResource)result)._getNodeKey());
             }
             else
             {
@@ -1230,16 +1223,16 @@
    {
       doWithNode(nodeId, new BaseDataType[] {outSiblingId, outSiblingKey}, n ->
       {
-         TreeNodeResource<N> parent = n._getParent();
+          TreeNodeFace parent = ((TreeNodeResource)n)._getParent();
          if (parent != null)
          {
-            TreeNodeCollectionResource<N,C,R> col = parent._getNodes();
+            TreeNodeCollectionResource col = ((TreeNodeResource)parent)._getNodes();
             int i = col._indexOf(n);
             if (i >= 1 && i < col._getCount())
             {
-               TreeNodeResource<N> result = col._getNode(i - 1);
-               outSiblingId.assign(result._getNodeId());
-               outSiblingKey.assign(result._getNodeKey());
+                TreeNodeFace result = col._getNode(i - 1);
+               outSiblingId.assign(((TreeNodeResource)result)._getNodeId());
+               outSiblingKey.assign(((TreeNodeResource)result)._getNodeKey());
             }
             else
             {
@@ -1264,11 +1257,11 @@
    {
       doWithNode(nodeId, new BaseDataType[] {outParentId, outParentKey}, n ->
       {
-         TreeNodeResource<N> parent = n._getParent();
+          TreeNodeFace parent = ((TreeNodeResource)n)._getParent();
          if (parent != null)
          {
-            outParentId.assign(parent._getNodeId());
-            outParentKey.assign(parent._getNodeKey());
+            outParentId.assign(((TreeNodeResource)parent)._getNodeId());
+            outParentKey.assign(((TreeNodeResource)parent)._getNodeKey());
          }
          else
          {
@@ -1291,7 +1284,7 @@
    @Override
    public integer getNodeLevel(character nodeKey)
    {
-      return doWithNode(nodeKey, null, new integer(), n -> new integer(n._getNodeLevel()));
+      return doWithNode(nodeKey, null, new integer(), n -> new integer(((TreeNodeResource)n)._getNodeLevel()));
    }
 
    /**
@@ -1301,11 +1294,11 @@
     *          the node to make the top visible
     */
    @Override
-   public void scrollNodeToTop(character nodeKey)
+   public void scrollNodeToTop(final character nodeKey)
    {
       doWithNode(nodeKey, null, n ->
       {
-         setAttr("topNode", config.topNode, n._getNodeId(), (int vv) -> config.topNode = vv);
+         setAttr("topNode", config.topNode, ((TreeNodeResource)n)._getNodeId(), (int vv) -> config.topNode = vv);
       });
    }
 
@@ -1476,11 +1469,11 @@
                                                                                 y.intValue());
          if (nodeId != null)
          {
-            R node = findNode(nodeId.intValue());
+             TreeNodeFace node = findNode(nodeId.intValue());
             
             if (node != null)
             {
-               return node.getNodeKey();
+               return ((TreeNodeResource)node).getNodeKey();
             }
          }
       }
@@ -1521,8 +1514,8 @@
    {
       doWithNode(nodeId, null, n ->
       {
-         n.setNodeIcon(icon);
-         n.setExpandNodeIcon(expandIcon);
+         ((TreeNodeResource)n).setNodeIcon(icon);
+         ((TreeNodeResource)n).setExpandNodeIcon(expandIcon);
          pushNodes();
       });
    }
@@ -1599,7 +1592,7 @@
          return new handle(rootNode);
       }
 
-      R node = findNode(nodeId);
+       TreeNodeFace node = findNode(nodeId);
       return new handle(node);
    }
 
@@ -1662,8 +1655,8 @@
    @Override
    public void collapseAllExcept(handle node)
    {
-      TreeNodeResource<N> n = node == null || node.isUnknown() ?
-                           null : (TreeNodeResource<N>) node.getResource();
+       TreeNodeFace n = node == null || node.isUnknown() ?
+                           null : (TreeNodeResource) node.getResource();
       setAllNodesExpanded(false, n);
    }
 
@@ -1685,7 +1678,7 @@
 
       handle node = findNode(nodeId);
       return new logical(!node.isUnknown() && 
-            ((TreeNodeResource<N>) node.getResource())._getHasChildren());
+            ((TreeNodeResource) node.getResource())._getHasChildren());
    }
 
    /**
@@ -1707,7 +1700,7 @@
       handle node = findNode(nodeId);
       if (!node.isUnknown())
       {
-         ((TreeNodeResource<N>) node.getResource())._setHasChildren(value.booleanValue());
+         ((TreeNodeResource) node.getResource())._setHasChildren(value.booleanValue());
       }
    }
 
@@ -1746,7 +1739,7 @@
    @Override
    public integer getTopVisibleNodeId()
    {
-      return new integer(getAttr("topNode", () -> config.topNode, true));
+      return new integer(_getTopVisibleNodeId());
    }
 
    /**
@@ -1788,7 +1781,7 @@
    @Override
    public character getNodeText(character nodeKey)
    {
-      return doWithNode(nodeKey, null, new character(), node -> node.getNodeText());
+      return doWithNode(nodeKey, null, new character(), node -> ((TreeNodeResource)node).getNodeText());
    }
 
    /**
@@ -1802,7 +1795,7 @@
    @Override
    public void setNodeText(character nodeKey, character text)
    {
-      doWithNode(nodeKey, new BaseDataType[] {text}, node -> node.setNodeText(text));
+      doWithNode(nodeKey, new BaseDataType[] {text}, node -> ((TreeNodeResource)node).setNodeText(text));
    }
 
    /**
@@ -1813,7 +1806,7 @@
    {
       character nodeKey = getSelectedNodeKey();
       
-      doWithNode(nodeKey, null, node -> node.setEditorMode(EditorMode.ACTIVATING));
+      doWithNode(nodeKey, null, node -> ((TreeNodeResource)node).setEditorMode(EditorMode.ACTIVATING));
    }
 
    /**
@@ -1874,11 +1867,12 @@
          return new integer();
       }
 
-      R node = findNode(nodeKey.toStringMessage());
+      final TreeNodeFace node = findNode(nodeKey.toStringMessage());
       if (node != null)
       {
-         return new integer(node.nodeId);
+         return new integer(((TreeNodeResource)node).nodeId);
       }
+      
       return new integer();
    }
 
@@ -2043,7 +2037,7 @@
       
       super.delete();
       
-      rootNode.delete();
+      ((TreeNodeResource)rootNode).delete();
    }
 
    /**
@@ -2109,7 +2103,7 @@
          return new handle();
       }
       
-      R node = getNodeByCoordinates(x.intValue(), y.intValue());
+       TreeNodeFace node = getNodeByCoordinates(x.intValue(), y.intValue());
       
       return node == null ? new handle() : new handle(node);
    }
@@ -2133,11 +2127,11 @@
          return new comhandle();
       }
       
-      R node = getNodeByCoordinates(x.intValue(), y.intValue());
+      final  TreeNodeFace node = getNodeByCoordinates(x.intValue(), y.intValue());
       
-      if (node instanceof TreeViewNodeResource)
+      if (node instanceof TreeNodeResource)
       {
-         return TreeViewNodeObject.newInstance((TreeViewNodeResource) node);
+         return TreeViewNodeObject.newInstance((TreeNodeResource) node);
       }
       return new comhandle();
    }
@@ -2184,15 +2178,15 @@
     * @param   pushNodes
     *          When set to {@code true} the new node being added will be pushed to the client.
     */
-   protected void addNode(R node, boolean pushNodes)
+   protected void addNode(final TreeNodeFace node, boolean pushNodes)
    {
-      final integer nodeId = node.getNodeId();
+      final integer nodeId = ((TreeNodeResource)node).getNodeId();
       if (nodeId.isUnknown())
       {
          throw new RuntimeException("Node id value must not be unknown!");
       }
 
-      final character nodeKey = node.getNodeKey();
+      final character nodeKey = ((TreeNodeResource)node).getNodeKey();
       if (nodeKey.isUnknown())
       {
          throw new RuntimeException("Node key value must not be unknown!");
@@ -2214,9 +2208,9 @@
       nodesByIndices.add(node);
 
       // this is the first node added to the tree-list; select it
-      if (node._getParent() == rootNode && rootNode._getNodes()._getCount() == 1)
+      if (((TreeNodeResource)node)._getParent() == rootNode && ((TreeNodeResource)rootNode)._getNodes()._getCount() == 1)
       {
-         _setSelectedNode(node._getNodeId());
+         _setSelectedNode(((TreeNodeResource)node)._getNodeId());
       }
       
       if (pushNodes)
@@ -2237,7 +2231,7 @@
     *
     * @return  new node instance.
     */
-   abstract protected R createNode(String key, String text, R parent);
+   abstract protected TreeNodeFace createNode(String key, String text, TreeNodeFace parent);
 
    /**
     * Allocates and returns next node id.
@@ -2254,7 +2248,7 @@
     *
     * @return  a tree root node instance.
     */
-   protected R getRootNode()
+   protected TreeNodeFace getRootNode()
    {
       return rootNode;
    }
@@ -2270,16 +2264,16 @@
          return;
       }
 
-      ArrayList<N> result = new ArrayList<>();
+      final List<TreeNodeEntry> result = new ArrayList<>();
       
-      TreeNodeCollectionResource<N,C,R> coll = rootNode._getNodes(false);
+      final TreeNodeCollectionResource coll = ((TreeNodeResource)rootNode)._getNodes(false);
       if (coll != null)
       {
-         Iterator<R> it = coll.recursiveIterator(false);
+         final Iterator <TreeNodeFace >  it = coll.recursiveIterator(false);
          while (it.hasNext())
          {
-            TreeNodeResource<N> node = it.next();
-            result.add((N) node.saveToEntry());
+            final  TreeNodeFace node = it.next();
+            result.add(((TreeNodeResource)node).saveToEntry());
          }
 
          setAttr("nodes", config.nodes, result, (vv) -> config.nodes = vv);
@@ -2319,10 +2313,10 @@
     * @param   pushNodes
     *          When set to {@code true} the model change will be pushed to the client.
     */
-   void removeNode(R node, boolean pushNodes)
+   void removeNode(final TreeNodeFace node, boolean pushNodes)
    {
-      nodesById.remove(node.getNodeId().intValue());
-      nodesByKey.remove(node.getNodeKey().toStringMessage());
+      nodesById.remove(((TreeNodeResource)node).getNodeId().intValue());
+      nodesByKey.remove(((TreeNodeResource)node).getNodeKey().toStringMessage());
       // The node is unique so its first occurrence can be removed from this collection
       nodesByIndices.remove(node);
 
@@ -2342,10 +2336,10 @@
     * @param    pushNodes
     *           When set to {@code true} the model change will be pushed to the client.
     */
-   void updateNode(R node, String oldKeyValue, boolean pushNodes)
+   void updateNode(final TreeNodeFace node, String oldKeyValue, boolean pushNodes)
    {
       nodesByKey.remove(oldKeyValue);
-      nodesByKey.put(node.getNodeKey().toStringMessage(), node);
+      nodesByKey.put(((TreeNodeResource)node).getNodeKey().toStringMessage(), node);
 
       if (pushNodes)
       {
@@ -2361,7 +2355,7 @@
     *
     * @return  a tree node instance or null if not found.
     */
-   R findNode(String key)
+    TreeNodeFace findNode(String key)
    {
       return nodesByKey.get(key);
    }
@@ -2374,7 +2368,7 @@
     *
     * @return  a tree node instance or null if not found.
     */
-   R findNode(int nodeId)
+   TreeNodeFace findNode(int nodeId)
    {
       return nodesById.get(nodeId);
    }
@@ -2390,7 +2384,7 @@
     *
     * @return   The tree node instance or null if an index is out of bounds.
     */
-   R getTreeNodeByIndex(int index)
+   TreeNodeFace getTreeNodeByIndex(int index)
    {
       if (index < 0 || index >= nodesByIndices.size())
       {
@@ -2408,7 +2402,7 @@
     *
     * @return   The 0-based index of the the target node.
     */
-   int getTreeNodeIndex(R node)
+   int getTreeNodeIndex(final TreeNodeFace node)
    {
       return nodesByIndices.indexOf(node);
    }
@@ -2458,7 +2452,7 @@
    protected <T extends BaseDataType> T doWithNode(NumberType nodeId,
                                                    BaseDataType[] mandatoryArgs,
                                                    T failResult,
-                                                   Function<R, T> body)
+                                                   Function<TreeNodeFace, T> body)
    {
       return doWithNodeImpl(nodeId,
                             mandatoryArgs,
@@ -2482,7 +2476,7 @@
     */
    protected void doWithNode(NumberType nodeId,
                              BaseDataType[] mandatoryArgs,
-                             Consumer<R> body)
+                             Consumer <TreeNodeFace>  body)
    {
       doWithNode(nodeId, mandatoryArgs, null, n ->
       {
@@ -2514,7 +2508,7 @@
    protected <T extends BaseDataType> T doWithNode(character nodeKey,
                                                    BaseDataType[] mandatoryArgs,
                                                    T failResult,
-                                                   Function<R, T> body)
+                                                   Function<TreeNodeFace, T> body)
    {
       return doWithNodeImpl(nodeKey,
                             mandatoryArgs,
@@ -2538,7 +2532,7 @@
     */
    protected void doWithNode(character nodeKey,
                              BaseDataType[] mandatoryArgs,
-                             Consumer<TreeNodeResource<N>> body)
+                             Consumer<TreeNodeFace> body)
    {
       doWithNode(nodeKey, mandatoryArgs, null, n ->
       {
@@ -2569,11 +2563,11 @@
     *
     * @return  see above
     */
-   protected <T extends BaseDataType> T doWithNodeImpl(BaseDataType nodeId,
+   protected static <T extends BaseDataType> T doWithNodeImpl(BaseDataType nodeId,
                                                        BaseDataType[] mandatoryArgs,
                                                        T failResult,
-                                                       Function<R, T> body,
-                                                       Function<BaseDataType, R> findNode)
+                                                       Function<TreeNodeFace, T> body,
+                                                       Function<BaseDataType, TreeNodeFace> findNode)
    {
       if (mandatoryArgs != null)
       {
@@ -2591,7 +2585,7 @@
          return failResult;
       }
 
-      R node = findNode.apply(nodeId);
+       TreeNodeFace node = findNode.apply(nodeId);
       if (node != null)
       {
          return body.apply(node);
@@ -2609,7 +2603,7 @@
     *
     * @return  see above.
     */
-   protected boolean assertKnown(BaseDataType... values)
+   protected static boolean assertKnown(BaseDataType... values)
    {
       for (BaseDataType val : values)
       {
@@ -2627,16 +2621,16 @@
     */
    void clearCollapsed()
    {
-      Iterator<TreeNodeResource<N>> it = rootNode._getNodes().recursiveIterator(true);
+      final Iterator<TreeNodeFace> it = ((TreeNodeResource)rootNode)._getNodes().recursiveIterator(true);
       while(it.hasNext())
       {
-         TreeNodeResource<N> node = it.next();
-         if (node._isNodeExpanded())
+          TreeNodeFace node = it.next();
+         if (((TreeNodeResource)node)._isNodeExpanded())
          {
             continue;
          }
 
-         TreeNodeCollectionResource<N, C, R> sub = node._getNodes(false);
+         TreeNodeCollectionResource sub = ((TreeNodeResource)node)._getNodes(false);
          if (sub != null && sub._getCount() > 0)
          {
             sub.clearNodes();
@@ -2652,29 +2646,29 @@
     * @param   exceptNode
     *          The node to exclude from collapsing/expanding, if null all nodes will be collapsed/expanded.
     */
-   private void setAllNodesExpanded(boolean expanded, TreeNodeResource<N> exceptNode)
+   private void setAllNodesExpanded(boolean expanded,  TreeNodeFace exceptNode)
    {
-      TreeNodeCollectionResource<N,C,R> nodes = rootNode._getNodes(false);
+      final TreeNodeCollectionResource nodes = ((TreeNodeResource)rootNode)._getNodes(false);
       if (nodes != null)
       {
-         Iterator<R> it = nodes.recursiveIterator(false);
+         Iterator <TreeNodeFace >  it = nodes.recursiveIterator(false);
          while(it.hasNext())
          {
-            TreeNodeResource<N> node = it.next();
-            if (node._isNodeExpanded() == expanded)
+             TreeNodeFace node = it.next();
+            if (((TreeNodeResource)node)._isNodeExpanded() == expanded)
             {
                continue;
             }
 
-            TreeNodeResource<N> check = exceptNode;
+             TreeNodeFace check = exceptNode;
             while(check != null)
             {
-               if (check._getNodeId() == node._getNodeId())
+               if (((TreeNodeResource)check)._getNodeId() == ((TreeNodeResource)node)._getNodeId())
                {
                   break;
                }
 
-               check = check._getParent();
+               check = ((TreeNodeResource)check)._getParent();
             }
 
             if (check != null)
@@ -2682,7 +2676,7 @@
                continue;
             }
 
-            node._setNodeExpanded(expanded);
+            ((TreeNodeResource)node)._setNodeExpanded(expanded);
          }
 
          pushNodes();
@@ -2694,7 +2688,7 @@
     * 
     * @return the selected node
     */
-   private final R _getSelectedNode()
+   private final  TreeNodeFace _getSelectedNode()
    {
       return nodesById.get(_getSelecteNodeId());
    }
@@ -2719,7 +2713,7 @@
     * 
     * @return   The tree node if there exists one, otherwise null.
     */
-   private R getNodeByCoordinates(int x, int y)
+   private  TreeNodeFace getNodeByCoordinates(int x, int y)
    {
       Integer nodeId = null;
       
@@ -2734,7 +2728,7 @@
          return null;
       }
       
-      R node = this.findNode(nodeId);
+      TreeNodeFace node = this.findNode(nodeId);
       
       return node;
    }
